﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Messaging;
using System.Text;

/*
 *         Progetto: Esempio d'uso delle code MSMQ
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 18/01/2016
 *  
 *      Descrizione: Trasmissione di un messaggio a una coda MSMQ.
 *                   
 *                   Aggiungere al progetto un riferimento all'assembly System.Messaging.
 *                   Per eseguire questa applicazione console, rendere pubblica la classe Trasmettitore.
 */

namespace Trasmettitore
{
    public class Trasmettitore
    {
        //public static string nomeCoda = @"FormatName:DIRECT=TCP:127.0.0.1\Private$\Esempio";
        public static string nomeCoda = @".\Private$\Esempio";

        public class Info
        {
            public int[] Numeri { get; set; }

            public override string ToString()
            {
                if (Numeri == null || Numeri.Count() == 0)
                    return String.Empty;

                StringBuilder sb = new StringBuilder();
                int i = 1;

                sb.Append(Numeri[0]);

                while (i < Numeri.Count())
                    sb.Append(", " + Numeri[i++]);

                return sb.ToString();
            }
        }
        
        static void Main(string[] args)
        {
            try
            {
                Console.WriteLine(String.Format("Trasmettitore avviato (coda {0})", nomeCoda));

                MessageQueue coda = new MessageQueue(nomeCoda);
                Message m = new Message();
                Random r = new Random();
                Info inf = new Info() { Numeri = new int[2] { r.Next(100), r.Next(100) } };

                m.Body = inf;
                coda.Send(m);

                Console.WriteLine("Inviata la sequenza {0}.", inf);
            }
            catch (Exception e)
            {
                Console.Error.WriteLine("Errore: {0}", e.Message);
            }
        }
    }
}
